// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from automotive_platform_msgs:msg/DriverCommands.idl
// generated code does not contain a copyright notice

#ifndef AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__TRAITS_HPP_
#define AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "automotive_platform_msgs/msg/detail/driver_commands__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace automotive_platform_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DriverCommands & msg,
  std::ostream & out)
{
  out << "{";
  // member: msg_counter
  {
    out << "msg_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.msg_counter, out);
    out << ", ";
  }

  // member: engage
  {
    out << "engage: ";
    rosidl_generator_traits::value_to_yaml(msg.engage, out);
    out << ", ";
  }

  // member: disengage
  {
    out << "disengage: ";
    rosidl_generator_traits::value_to_yaml(msg.disengage, out);
    out << ", ";
  }

  // member: speed_up
  {
    out << "speed_up: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_up, out);
    out << ", ";
  }

  // member: slow_down
  {
    out << "slow_down: ";
    rosidl_generator_traits::value_to_yaml(msg.slow_down, out);
    out << ", ";
  }

  // member: further
  {
    out << "further: ";
    rosidl_generator_traits::value_to_yaml(msg.further, out);
    out << ", ";
  }

  // member: closer
  {
    out << "closer: ";
    rosidl_generator_traits::value_to_yaml(msg.closer, out);
    out << ", ";
  }

  // member: right_turn
  {
    out << "right_turn: ";
    rosidl_generator_traits::value_to_yaml(msg.right_turn, out);
    out << ", ";
  }

  // member: left_turn
  {
    out << "left_turn: ";
    rosidl_generator_traits::value_to_yaml(msg.left_turn, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DriverCommands & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: msg_counter
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "msg_counter: ";
    rosidl_generator_traits::value_to_yaml(msg.msg_counter, out);
    out << "\n";
  }

  // member: engage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "engage: ";
    rosidl_generator_traits::value_to_yaml(msg.engage, out);
    out << "\n";
  }

  // member: disengage
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "disengage: ";
    rosidl_generator_traits::value_to_yaml(msg.disengage, out);
    out << "\n";
  }

  // member: speed_up
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed_up: ";
    rosidl_generator_traits::value_to_yaml(msg.speed_up, out);
    out << "\n";
  }

  // member: slow_down
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "slow_down: ";
    rosidl_generator_traits::value_to_yaml(msg.slow_down, out);
    out << "\n";
  }

  // member: further
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "further: ";
    rosidl_generator_traits::value_to_yaml(msg.further, out);
    out << "\n";
  }

  // member: closer
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "closer: ";
    rosidl_generator_traits::value_to_yaml(msg.closer, out);
    out << "\n";
  }

  // member: right_turn
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "right_turn: ";
    rosidl_generator_traits::value_to_yaml(msg.right_turn, out);
    out << "\n";
  }

  // member: left_turn
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "left_turn: ";
    rosidl_generator_traits::value_to_yaml(msg.left_turn, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DriverCommands & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace automotive_platform_msgs

namespace rosidl_generator_traits
{

[[deprecated("use automotive_platform_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const automotive_platform_msgs::msg::DriverCommands & msg,
  std::ostream & out, size_t indentation = 0)
{
  automotive_platform_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use automotive_platform_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const automotive_platform_msgs::msg::DriverCommands & msg)
{
  return automotive_platform_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<automotive_platform_msgs::msg::DriverCommands>()
{
  return "automotive_platform_msgs::msg::DriverCommands";
}

template<>
inline const char * name<automotive_platform_msgs::msg::DriverCommands>()
{
  return "automotive_platform_msgs/msg/DriverCommands";
}

template<>
struct has_fixed_size<automotive_platform_msgs::msg::DriverCommands>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<automotive_platform_msgs::msg::DriverCommands>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<automotive_platform_msgs::msg::DriverCommands>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOMOTIVE_PLATFORM_MSGS__MSG__DETAIL__DRIVER_COMMANDS__TRAITS_HPP_
